### https://docs.broadcom.com/docs-and-downloads/docs/linux_sta/hybrid-v35_64-nodebug-pcoem-6_30_223_271.tar.gz
%define debug_package %{nil}
%define oname	hybrid-v35
%define dwver	6_30_223_271
%define kname	wl

Summary:	Proprietary driver for Broadcom wireless adapters
Name:		broadcom-wl
Version:	6.30.223.271
Release:	1uplos2018
Source0:	http://www.broadcom.com/docs/linux_sta/%{oname}-nodebug-pcoem-%{dwver}.tar.gz
Source1:	http://www.broadcom.com/docs/linux_sta/%{oname}_64-nodebug-pcoem-%{dwver}.tar.gz
Source2:	broadcom-wl-blacklist.conf
Source3:	broadcom-wl-alias.conf
Patch1: 001-null-pointer-fix.patch
Patch2: 002-rdtscl.patch
Patch3: 003-linux47.patch
Patch4: 004-linux48.patch
Patch5: 005-debian-fix-kernel-warnings.patch
Patch6: 006-linux411.patch
Patch7: 007-linux412.patch
License:	Freeware and GPLv2 with exception
Group:		System/Kernel and hardware
URL:		http://www.broadcom.com/support/802.11/linux_sta.php


%description
For older kernel-versions < 4.11 please use the release 4 of this package!
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n dkms-%{name}
Summary:	Kernel module for Broadcom wireless adapters linux-4.11.
Group:		System/Kernel and hardware
Provides:	kmod(%{kname}.ko) = %{version}
Requires(post):		dkms
Requires(preun):	dkms
Requires:	broadcom-wl-blacklist
BuildArch:	noarch

%description -n dkms-%{name}
For older kernel-versions < 4.11 please use the release 4 of this package!
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%prep
%ifarch x86_64
%setup -q -T -c -a1 %{oname}
%else
%setup -q -T -c -a0 %{oname}
%endif

%apply_patches

sed -e "/BRCM_WLAN_IFNAME/s:eth:wlan:" -i src/wl/sys/wl_linux.c

%build

%install
rm -rf %{buildroot}

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp -R * %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
MAKE="make -C \$kernel_source_dir M=\\\$(pwd)"
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
DEST_MODULE_LOCATION=/kernel/3rdparty/%{name}
BUILT_MODULE_NAME=%{kname}
AUTOINSTALL=yes
EOF

%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} &&
/usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release}

%preun -n dkms-%{name}
# rmmod can fail
/sbin/rmmod %{kname} >/dev/null 2>&1 ||:
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || :

%posttrans
if [ -z "$DURING_INSTALL" ] ; then
    /sbin/rmmod b43 >/dev/null 2>&1 ||:
    /sbin/rmmod b43legacy >/dev/null 2>&1 ||:
    /sbin/rmmod brcmfmac >/dev/null 2>&1 ||:
    /sbin/rmmod brcmsmac >/dev/null 2>&1 ||:
    /sbin/rmmod bcma >/dev/null 2>&1 ||:
    /sbin/rmmod ssb >/dev/null 2>&1 ||:
    /sbin/modprobe wl >/dev/null 2>&1 ||:
fi

%clean
rm -rf %{buildroot}

%files -n dkms-%{name}
%doc lib/LICENSE.txt
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*

%changelog
* Sun Jan 14 2018 threepio <threepiouplos@protonmail.com> 5.30.223.271-7pclos2018
- rebuild and update for uplos

* Mon Jul 17 2017 bb2 <bb2> - 5.30.223.271-7pclos2017
- update for kernel 4.12

* Mon May 22 2017 bb2 <bb2> - 6.30.223.271-6pclos2017
- use arch build and patches

* Fri May 19 2017 onkelho <oh.quait@gmail.com> 6.30.223.271-5pclos2017
- rebuild 

* Sun Jan 22 2017 onkelho <oh.quait@gmail.com> 6.30.223.271-4pclos2017
- dkms as noarch

* Sun Jan 22 2017 onkelho <oh.quait@gmail.com> 6.30.223.271-3pclos2017
- new version build
- test on 4.9.5

* Sat Aug 27 2016 bb <bb> 6.30.223.271-2pclos2016
- fix build for kernel 4.7

* Tue May 31 2016 bb <bb> 6.30.223.271-1pclos2016
- update

* Mon Feb 01 2016 bb <bb> 6.30.233.248-4pclos2016
- patch for kernel 4.1.x and 4.4.x fix

* Wed Sep 30 2015 bb <bb> 6.30.233.248-3pclos2015
- update for kernel 4.2.x

* Thu Apr 30 2015 bb <bb> 6.30.223.248-2pclos2015
- update for kernel 4.0.x

* Wed Dec 17 2014 bb <bb> 6.30.223.248-1pclos2014
- update for kernel 3.18
